﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using Contracts;

namespace Client
{
    class Program
    {
        static void Main(string[] args)
        {
            ICalculator2 menuProxy = CrateProxy<ICalculator2>("calculatorservice2"); //方法一，使用泛型，方便实用，可扩展性强，缺点，木有回调了
            var r = menuProxy.Subtraction(120, 5);
            Console.WriteLine("x-y={0}", r);

            InstanceContext instanceContext = new InstanceContext(new CalculatorCallbackService());
            using (DuplexChannelFactory<ICalculator> channelFactory = new DuplexChannelFactory<ICalculator>(instanceContext, "calculatorservice"))
            {
                ICalculator proxy = channelFactory.CreateChannel();
                using (proxy as IDisposable)
                {
                    proxy.Add(1, 2);//方法二，有回调
                    var result = proxy.Subtraction(100, 1);//方法三，使用using,不使用回调
                    Console.WriteLine("x-y={0}", result);
                    Console.Read();
                }
            }
        }

        public static T CrateProxy<T>(String endpoint)
        {            
            ChannelFactory<T> channelFactory = new ChannelFactory<T>(endpoint);
            T proxy = channelFactory.CreateChannel();
            return proxy;
        }
    }
}
